--[[
     --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


				     #######     ####           ####       #                     #######     #   #######
				   ##          ##    ##       ##    ##     #                    #       #    #   #      ##
				  #           #        #     #        #    #                   #         #   #   #        #
				 #           #          #   #          #   #                   #         #   #   #         #
				 #           #          #   #          #   #                   ###########   #   #         #
				 #           #          #   #          #   #                   #         #   #   #         #
				  #           #        #     #        #    #                   #         #   #   #        #
				   ##          ##    ##       ##    ##     #                   #         #   #   #      ##
				     #######     ####           ####       ###########         #         #   #   #######


      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

					     --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

									  INTERFACE

					     --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--
]]

ca_Interface, ca_optionsFrame, ca_cooldownsFrame, ca_helpFrame, ca_troubleFrame, ca_aboutFrame = nil, nil, nil, nil, nil, nil

-- Colours
----------
local ca_colour_processCyan		= "\124cFF00B7EB"	-- CoolAid chat line prefix
local ca_colour_dodgerBlue		= "\124cFF1e90ff"	-- Highlight and warning messages
local ca_colour_lightCornflowerBlue	= "\124cFF93CCEA"	-- Plain text
local ca_colour_electricCyan		= "\124cFF00FFFF"	-- Error messages
local ca_colour_electricBlue		= "\124cFF7DF9FF"	-- Debug messages

local selected_sCooldown, selected_spellbook, selected_Source = 0, 0, 0
local cd_sButton1, cd_sButton2, cd_sButton3, cd_sButton4 = nil, nil, nil, nil
local cdSCooldowns, cdSpellbook, cdBags = {}, {}, {}
local ca_StrSpellbook, ca_StrEquipment, ca_StrBuffs, ca_StrDebuffs, ca_SpellID, ca_ItemID = "Spell Book", "Equipment", "Player Buffs", "Player Debuffs", "Spell ID", "Item ID"
local numOfSSpells, numOfSCDs = 100, 42
local ca_spellItemID = ""

local ceil = ceil
local ipairs = ipairs
local pairs = pairs

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::       TEMPLATES       :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local interfaceWidth = 592.5			-- had trouble extracting this from API calls so had to measure it myself

local function Divider( leftOffset, rightOffset, rightDown, anchor, frame, header, width)

	-- Blizzard uses space of 5 around the header and a minimum of 16 in from left edge and 17 from the right edge
	-- Using standard Blizzard colours here
	-- Very different/improved to We Don't Wipe but *still* a work in progress this routine :(

	if not width then width = interfaceWidth end

	local heading = frame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	heading:SetText(header)
	heading:SetTextColor( NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)

	local headingStart = 0
	if width == interfaceWidth then
		headingStart = (width - heading:GetWidth()) / 2
	else
		headingStart = leftOffset + (width - heading:GetWidth()) / 2
	end
	heading:SetPoint("TOPLEFT", anchor, "BOTTOMLEFT", headingStart, rightDown)

	local leftSide = frame:CreateTexture(nil, "BACKGROUND")
	leftSide:SetHeight(8)

	if width == interfaceWidth then
		leftSide:SetPoint("LEFT", heading, "LEFT", leftOffset - headingStart, 0)
	else
		leftSide:SetPoint("LEFT", heading, "LEFT", leftOffset - headingStart, 0)
	end

	leftSide:SetPoint("RIGHT", heading, "LEFT", -5, 0)
	leftSide:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	leftSide:SetTexCoord(0.81, 0.94, 0.5, 1)

	local rightSide = frame:CreateTexture(nil, "BACKGROUND")
	rightSide.parent = anchor
	rightSide:SetHeight(8)
	rightSide:SetPoint("LEFT", heading, "RIGHT", 5, 0)

	if width == interfaceWidth then
		rightSide:SetPoint("RIGHT", - rightOffset, 0)
	else
		rightSide:SetPoint("RIGHT", - rightOffset, 0)
	end

	rightSide:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	rightSide:SetTexCoord(0.81, 0.94, 0.5, 1)

	return leftSide, heading, rightSide
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

local function CheckBox( left, up, anchor, frame, field, name, tooltip)

	local button = CreateFrame( "CheckButton", "CoolAidButton_"..name, frame, "OptionsCheckButtonTemplate")
	button:SetPoint("TOPLEFT", anchor, "BOTTOMLEFT", left, up)
	local button_label = frame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	button_label:SetText(name)
	button_label:SetPoint("LEFT", button, "RIGHT", 0, 0)
	button_label:SetTextColor(1,1,1,1)
	button.tooltip = tooltip or ""

	if CoolAidDB[ca_currentSpec][field] ==  1 then button:SetChecked(1) else button:SetChecked() end
	button.origValue = CoolAidDB[ca_currentSpec][field] or self.origValue

	function button:Restore()
		CoolAidDB[ca_currentSpec][field] = self.origValue
		if CoolAidDB[ca_currentSpec][field] ==  1 then button:SetChecked(1) else button:SetChecked() end
	end

	button:SetScript("OnClick", function(self)
		CoolAidDB[ca_currentSpec][field] = (CoolAidDB[ca_currentSpec][field] * -1) + 1
		if CoolAidDB[ca_currentSpec][field] ==  1 then button:SetChecked(1) else button:SetChecked() end
	end)

	button:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
		GameTooltip:SetText( self.tooltip, nil, nil, nil, nil, true)
	end)

	button:SetScript("OnLeave", function(self)
		ResetCursor()
		GameTooltip:Hide()
	end)

	button:SetScript("OnShow", function(self)
		self.origValue = CoolAidDB[ca_currentSpec][field] or self.origValue
		if CoolAidDB[ca_currentSpec][field] ==  1 then button:SetChecked(1) else button:SetChecked() end
	end)

	return button
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

local function Slider(left, up, anchor, frame, lo, hi, step, field, name, tooltip)

	local slider = CreateFrame('Slider', "CoolAidSlider_"..name, frame, 'OptionsSliderTemplate')
	slider:SetPoint("TOPLEFT", anchor, "BOTTOMLEFT", left+8, up-3)
	getglobal("CoolAidSlider_"..name.."Text"):SetText( name)
	getglobal("CoolAidSlider_"..name.."Low"):SetText( lo)
	getglobal("CoolAidSlider_"..name.."High"):SetText( hi)
	slider:SetMinMaxValues( lo, hi)
	slider:SetValueStep(step)
	slider:SetValue( CoolAidDB[ca_currentSpec][field])
	local text = slider:CreateFontString(nil, 'BACKGROUND')
	text:SetFontObject('GameFontHighlightSmall')
	text:SetPoint('LEFT', slider, 'RIGHT', -79, -10)
	slider.step = step
	slider.tooltip = tooltip or ""

	local _, tempF = math.modf(step)
	if tempF == 0 then
		slider.places = 0
	else
		local tempStep = math.floor(tempF*10) / 10
		if tempStep == step then
			slider.places = 1
		else
			tempStep = math.floor(tempF*100) / 100
			if tempStep == step then
				slider.places = 2
			else
				slider.places = 3
			end
		end
	end
	text:SetText( caRound(CoolAidDB[ca_currentSpec][field],slider.places))

	function slider:Restore()
		CoolAidDB[ca_currentSpec][field] = self.origValue
		text:SetText( CoolAidDB[ca_currentSpec][field])
	end

	slider:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
		GameTooltip:SetText( self.tooltip, nil, nil, nil, nil, true)
	end)
	slider:SetScript("OnLeave", function(self)
		ResetCursor()
		GameTooltip:Hide()
	end)

	slider:SetScript('OnValueChanged', function(self, value)
		CoolAidDB[ca_currentSpec][field] = caRound(value,self.places)
		text:SetText( caRound(CoolAidDB[ca_currentSpec][field],self.places))
	end)

	slider:SetScript("OnShow", function(self)
		self:SetValue( CoolAidDB[ca_currentSpec][field])
		self.origValue = CoolAidDB[ca_currentSpec][field] or self.origValue
	end)

	return slider
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

local function Button( left, up, anchor, frame, label, name, tooltip)

	local button = CreateFrame( "Button", "CoolAidButton_"..name, frame, "UIPanelButtonTemplate")
	getglobal( "CoolAidButton_"..name.."Text"):SetText( label)
	local text = button:CreateFontString(nil, "BACKGROUND")
	text:SetFontObject("GameFontHighlightSmall")	-- Auto centred by Blizz
	button:SetWidth(96)	-- Default height is 22
	button:SetPoint("TOPLEFT", anchor, "TOPLEFT", left, up)
	button.tooltip = tooltip or ""

	button:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
		GameTooltip:SetText( self.tooltip, nil, nil, nil, nil, true)
	end)

	button:SetScript("OnLeave", function(self)
		ResetCursor()
		GameTooltip:Hide()
	end)

	return button
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::  ADJUSTING & FILLING  :::]>=--							   ||--
--||							--=<[:::      PANEL DATA       :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local function AdjustButtons()

	if selected_sCooldown == 0 and selected_spellbook == 0 then
		cd_sButton1:Hide()
		cd_sButton2:Hide()
		cd_sButton3:Hide()
		cd_sButton4:Hide()
		return
	end

	if selected_spellbook ~= 0 then		-- selected spells

		if #CoolAidDB[ca_currentSpec].showCDs_1 == 0 then
			CoolAidButton_s1Text:SetText( "Add")
			CoolAidButton_s4Text:SetText( "Clear")
			cd_sButton1:Show()
			cd_sButton2:Hide()
			cd_sButton3:Hide()
			cd_sButton4:Show()
		elseif selected_sCooldown == 0 then
			CoolAidButton_s1Text:SetText( "Insert Start")
			CoolAidButton_s2Text:SetText( "Insert End")
			CoolAidButton_s4Text:SetText( "Clear")
			cd_sButton1:Show()
			cd_sButton2:Show()
			cd_sButton3:Hide()
			cd_sButton4:Show()
		else
			CoolAidButton_s1Text:SetText( "Insert Before")
			CoolAidButton_s2Text:SetText( "Insert After")
			CoolAidButton_s3Text:SetText( "Delete")
			CoolAidButton_s4Text:SetText( "Clear")
			cd_sButton1:Show()
			cd_sButton2:Show()
			cd_sButton3:Show()
			cd_sButton4:Show()
		end
	else								-- no selected spells or items
		if selected_sCooldown == 0 then
			cd_sButton1:Hide()
			cd_sButton2:Hide()
			cd_sButton3:Hide()
			cd_sButton4:Hide()
		else
			CoolAidButton_s3Text:SetText( "Delete")
			CoolAidButton_s4Text:SetText( "Clear")
			cd_sButton1:Hide()
			cd_sButton2:Hide()
			cd_sButton3:Show()
			cd_sButton4:Show()
			if selected_sCooldown >= 2 then
				CoolAidButton_s1Text:SetText( "Shuffle Up")
				cd_sButton1:Show()
			end
			if selected_sCooldown < #CoolAidDB[ca_currentSpec].showCDs_1 then
				CoolAidButton_s2Text:SetText( "Shuffle Down")
				cd_sButton2:Show()
			end
		end
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

local function ShowCooldowns()

	local j = 1

	for i,v in ipairs(CoolAidDB[ca_currentSpec].showCDs_1) do

		if i > numOfSCDs then
			caError("Cool Aid can display a maximum of "..numOfSCDs.." 'shown' cooldowns")
			break
		elseif i == numOfSCDs then
			caWarning("You have reached the maximum ("..numOfSCDs..") for 'shown' cooldowns")
		end

		if v > 0 then
			-- Testing showed that upon changing zones we come here about 4 times, and the first three times might result
			-- in expected spells not actually being in the Spellbook. Whatever...
			if ca_spellbook[tostring(v)] then
				cdSCooldowns[i].spellTexture:SetTexture(ca_spellbook[tostring(v)]["icon"])
			else
				local _,_,texture = GetSpellInfo(v)
				cdSCooldowns[i].spellTexture:SetTexture(texture)
			end
		else
			local texture = GetItemIcon(-v)
			cdSCooldowns[i].spellTexture:SetTexture(texture)
		end
		cdSCooldowns[i].spellID = v
		cdSCooldowns[i].index = i

		cdSCooldowns[i]:SetScript("OnEnter", function(self)
			GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
			if v > 0 then
				GameTooltip:SetSpellByID( v)
			else
				GameTooltip:SetItemByID( -v)
			end
		end)
		cdSCooldowns[i]:SetScript("OnClick", function(self)
			if selected_sCooldown ~= 0 then
				cdSCooldowns[selected_sCooldown].overlay:Hide()
			end
			selected_sCooldown = self.index
			AdjustButtons()
			self.overlay:Show()
			self.overlay.animIn:Play()
			PlaySoundFile("Sound/Interface/Mapping.Ogg")
		end)

		cdSCooldowns[i]:Show()
		j=j+1
	end

	for i=j,numOfSCDs do
		cdSCooldowns[i]:Hide()
	end

	if selected_sCooldown ~= 0 then
		cdSCooldowns[selected_sCooldown].overlay.animIn:Play()
	end
end

local function ShowSpellbook()

	cdBags = nil
	cdBags = { ca_StrSpellbook, ca_StrEquipment, ca_StrBuffs, ca_StrDebuffs, ca_SpellID, ca_ItemID}
	table.insert(cdBags,GetBagName(BACKPACK_CONTAINER))
	for i =1,NUM_BAG_SLOTS do
		local name = GetBagName(i)
		if name then table.insert(cdBags,("("..i..") "..name)) end
	end

	local i = 1

	if selected_Source == 1 then				-- Spellbook

		for k,v in pairs(ca_spellbook) do

			k = tonumber(k)
			local foundS = false
			for j,w in ipairs(CoolAidDB[ca_currentSpec].showCDs_1) do
				if w == k then
					foundS = true
					break
				end
			end
			if not foundS then
				cdSpellbook[i].spellTexture:SetTexture( v["icon"])
				cdSpellbook[i].spellID = k
				cdSpellbook[i].index = i
				cdSpellbook[i].overlay:Hide()

				cdSpellbook[i]:SetScript("OnEnter", function(self)
					GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
					GameTooltip:SetSpellByID( k)
				end)
				cdSpellbook[i]:SetScript("OnClick", function(self)
					if selected_spellbook ~= 0 then
						cdSpellbook[selected_spellbook].overlay:Hide()
					end
					selected_spellbook = self.index
					AdjustButtons()
					self.overlay.animIn:Play()
					PlaySoundFile("Sound/Interface/Mapping.Ogg")
				end)

				cdSpellbook[i]:Show()
				i=i+1
			end
		end

	elseif selected_Source == 2 then			-- Equipment

		for v=INVSLOT_FIRST_EQUIPPED,INVSLOT_LAST_EQUIPPED do
			local itemID = GetInventoryItemID("player",v)
			if itemID then
				local foundS = false
				for j,w in ipairs(CoolAidDB[ca_currentSpec].showCDs_1) do
					if w == -itemID then
						foundS = true
						break
					end
				end
				if not foundS then
					local texture = GetInventoryItemTexture("player", v)
					cdSpellbook[i].spellTexture:SetTexture( texture)
					cdSpellbook[i].spellID = -itemID
					cdSpellbook[i].index = i
					cdSpellbook[i].overlay:Hide()

					cdSpellbook[i]:SetScript("OnEnter", function(self)
						GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
						GameTooltip:SetItemByID( itemID)
					end)
					cdSpellbook[i]:SetScript("OnClick", function(self)
						if selected_spellbook ~= 0 then
							cdSpellbook[selected_spellbook].overlay:Hide()
						end
						selected_spellbook = self.index
						AdjustButtons()
						self.overlay.animIn:Play()
						PlaySoundFile("Sound/Interface/Mapping.Ogg")
					end)

					cdSpellbook[i]:Show()
					i=i+1
				end
			end
		end

	elseif selected_Source == 3 then			-- Player Buffs

		for k,v in pairs(ca_buffsPlayer) do
			local spellID = tonumber(k)
			local _,_,texture = GetSpellInfo(spellID)
			cdSpellbook[i].spellTexture:SetTexture(texture)
			cdSpellbook[i].spellID = spellID
			cdSpellbook[i].index = i
			cdSpellbook[i].overlay:Hide()

			cdSpellbook[i]:SetScript("OnEnter", function(self)
				GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
				GameTooltip:SetSpellByID( spellID)
			end)
			cdSpellbook[i]:SetScript("OnClick", function(self)
				if selected_spellbook ~= 0 then
					cdSpellbook[selected_spellbook].overlay:Hide()
				end
				selected_spellbook = self.index
				AdjustButtons()
				self.overlay.animIn:Play()
				PlaySoundFile("Sound/Interface/Mapping.Ogg")
			end)

			cdSpellbook[i]:Show()
			i=i+1
		end

	elseif selected_Source == 4 then			-- Player Debuffs

		for k,v in pairs(ca_debuffsPlayer) do
			local spellID = tonumber(k)
			local _,_,texture = GetSpellInfo(spellID)
			cdSpellbook[i].spellTexture:SetTexture( texture)
			cdSpellbook[i].spellID = spellID
			cdSpellbook[i].index = i
			cdSpellbook[i].overlay:Hide()

			cdSpellbook[i]:SetScript("OnEnter", function(self)
				GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
				GameTooltip:SetSpellByID( spellID)
			end)
			cdSpellbook[i]:SetScript("OnClick", function(self)
				if selected_spellbook ~= 0 then
					cdSpellbook[selected_spellbook].overlay:Hide()
				end
				selected_spellbook = self.index
				AdjustButtons()
				self.overlay.animIn:Play()
				PlaySoundFile("Sound/Interface/Mapping.Ogg")
			end)

			cdSpellbook[i]:Show()
			i=i+1
		end

	elseif selected_Source == 5 then			-- Spell ID

		if selected_spellbook ~= 0 then
			cdSpellbook[selected_spellbook].overlay:Hide()
			selected_spellbook = 0
		end

		local _,_,texture = GetSpellInfo(ca_spellItemID)
		cdSpellbook[i].spellTexture:SetTexture(texture)
		cdSpellbook[i].overlay:Hide()

		if texture then
			ca_spellItemID = tonumber(ca_spellItemID)
			cdSpellbook[i].spellID = ca_spellItemID
			cdSpellbook[i].index = i
			cdSpellbook[i]:SetScript("OnEnter", function(self)
				GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
				GameTooltip:SetSpellByID( ca_spellItemID)
			end)
			cdSpellbook[i]:SetScript("OnClick", function(self)
				selected_spellbook = self.index
				AdjustButtons()
				self.overlay.animIn:Play()
				PlaySoundFile("Sound/Interface/Mapping.Ogg")
			end)
		else
			cdSpellbook[i].spellID = 0
			cdSpellbook[i].index = 0
			cdSpellbook[i]:SetScript("OnEnter", function(self)
				GameTooltip:Hide()
			end)
			cdSpellbook[i]:SetScript("OnClick", nil)
		end

		AdjustButtons()
		cdSpellbook[i]:Show()
		i=i+1

	elseif selected_Source == 6 then			-- Item ID

		if selected_spellbook ~= 0 then
			cdSpellbook[selected_spellbook].overlay:Hide()
			selected_spellbook = 0
		end

		local texture = GetItemIcon(ca_spellItemID)
		cdSpellbook[i].spellTexture:SetTexture(texture)
		cdSpellbook[i].overlay:Hide()

		if texture then
			ca_spellItemID = tonumber(ca_spellItemID)
			cdSpellbook[i].spellID = -ca_spellItemID
			cdSpellbook[i].index = i
			cdSpellbook[i]:SetScript("OnEnter", function(self)
				GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
				GameTooltip:SetItemByID( ca_spellItemID)
			end)
			cdSpellbook[i]:SetScript("OnClick", function(self)
				selected_spellbook = self.index
				AdjustButtons()
				self.overlay.animIn:Play()
				PlaySoundFile("Sound/Interface/Mapping.Ogg")
			end)
		else
			cdSpellbook[i].spellID = 0
			cdSpellbook[i].index = 0
			cdSpellbook[i]:SetScript("OnEnter", function(self)
				GameTooltip:Hide()
			end)
			cdSpellbook[i]:SetScript("OnClick", nil)
		end

		AdjustButtons()
		cdSpellbook[i]:Show()
		i=i+1

	else							-- Bags. (selected_Source - 7) = the Container ID

		local slots, container = GetContainerNumSlots( selected_Source - 7), selected_Source - 7
		if slots then
			for s=1,slots do
				local itemID = GetContainerItemID( container, s)
				if itemID then
					local foundS = false
					for j,w in ipairs(CoolAidDB[ca_currentSpec].showCDs_1) do
						if w == -itemID then
							foundS = true
							break
						end
					end
					local duplicate = false
					for j=1,(i-1) do
						if cdSpellbook[j].spellID == -itemID then
							duplicate = true
						end
					end
					if not foundS and not duplicate then
						local texture = GetContainerItemInfo( container, s)
						cdSpellbook[i].spellTexture:SetTexture( texture)
						cdSpellbook[i].spellID = -itemID
						cdSpellbook[i].index = i
						cdSpellbook[i].overlay:Hide()

						cdSpellbook[i]:SetScript("OnEnter", function(self)
							GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
							GameTooltip:SetItemByID( itemID)
						end)
						cdSpellbook[i]:SetScript("OnClick", function(self)
							if selected_spellbook ~= 0 then
								cdSpellbook[selected_spellbook].overlay:Hide()
							end
							selected_spellbook = self.index
							AdjustButtons()
							self.overlay.animIn:Play()
							PlaySoundFile("Sound/Interface/Mapping.Ogg")
						end)

						cdSpellbook[i]:Show()
						i=i+1
					end
				end
			end
		end		
	end

	for j=i,numOfSSpells do
		cdSpellbook[j]:Hide()
	end

	if selected_spellbook ~= 0 then
		cdSpellbook[selected_spellbook].overlay.animIn:Play()
	end
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::    DATA MANAGEMENT    :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local setAside_options, setAside_sCooldowns = {}, {}

local function SetAsideAllData()

	-- Options
	for k,v in pairs(CoolAidDB[ca_currentSpec]) do
		setAside_options[k] = v
	end

	-- Cooldowns
	for i=1,#setAside_sCooldowns do
		table.remove( setAside_sCooldowns)
	end
	for i,v in ipairs(CoolAidDB[ca_currentSpec].showCDs_1) do
		table.insert( setAside_sCooldowns, v)
	end
end

local function CommonAllData()

	SetAsideAllData()
	ShowCooldowns()
	ShowSpellbook()
	CoolAid:ResolveSpecFillSpellbook()
	CoolAid:RepositionFrames()
	AdjustButtons()
end

local function CancelAllData()

	-- Essentially overwriting the current values with values saved previously

	-- Options
	for k,v in pairs(setAside_options) do
		CoolAidDB[ca_currentSpec][k] = v
	end

	-- Cooldowns
	for i=1,#CoolAidDB[ca_currentSpec].showCDs_1 do
		table.remove( CoolAidDB[ca_currentSpec].showCDs_1)
	end
	for i,v in ipairs(setAside_sCooldowns) do
		table.insert( CoolAidDB[ca_currentSpec].showCDs_1, v)
	end

	if selected_sCooldown ~= 0 then
		cdSCooldowns[selected_sCooldown].overlay:Hide()
		selected_sCooldown = 0
	end
	if selected_spellbook ~= 0 then
		cdSpellbook[selected_spellbook].overlay:Hide()
		selected_spellbook = 0
	end

	CommonAllData()
end

local function DefaultAllData()

	-- Options
	for k,v in pairs(CoolAidDB.defaults) do
		if k ~= "showCDs_1" then
			CoolAidDB[ca_currentSpec][k] = v
		end
	end

	-- Shown Cooldowns
	for i=1,#CoolAidDB[ca_currentSpec].showCDs_1 do
		table.remove( CoolAidDB[ca_currentSpec].showCDs_1)
	end

	if selected_sCooldown ~= 0 then
		cdSCooldowns[selected_sCooldown].overlay:Hide()
		selected_sCooldown = 0
	end
	if selected_spellbook ~= 0 then
		cdSpellbook[selected_spellbook].overlay:Hide()
		selected_spellbook = 0
	end

	CommonAllData()
end

local function OkayAllData()

	CommonAllData()
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::        OPTIONS        :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local fourAcrossCB = { -4, 145, 294, 443}	-- four very evenly spaced columns. Ideal for checkboxes
local threeAcrossCB = { -4, 194.8, 393.6}	-- An improvement on Ace horizontal spacing to be sure. Very evenly spaced
local closeRowsCB = { -5, -35, -65, -95}	-- goes nicely with four across
local aceRowsCB = { -23, -64, -105, -146}	-- Quite similar to Ace vertical spacing but with improvements

-------------------------------------------------------------------------------------------------------------------------------------------------------

local function CoolAidOptions()

	ca_optionsFrame = CreateFrame( "Frame", "caOptions", ca_Interface)
	ca_optionsFrame.name = "Options"
	ca_optionsFrame.parent = ca_Interface.name

	local title = ca_optionsFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormalLarge")
	title:SetPoint('TOPLEFT',16,-16)
	title:SetText("Cool Aid - Options")
	title:SetTextColor( NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)

	local divider1 = Divider( 0, 17, -15, title, ca_optionsFrame, "Tile Structure")

	Slider( threeAcrossCB[1], aceRowsCB[1], divider1, ca_optionsFrame, 15, 200, 1, "tileSize", "Tile Size", 
			"BEWARE: Setting very small/large then moving behind the hotbars at the bottom of the screen and then resizing "..
			"may result in you not being able to move your Cool Aid tiles.\n")
	local anchor1 = Slider( threeAcrossCB[1], aceRowsCB[2], divider1, ca_optionsFrame, 1, 25, 1, "horizontal", "Horizontal Tiles", 
			"The number of tiles to stretch across the screen before a new row will begin.\n"..ca_colour_dodgerBlue..
			"(Use '1' for vertical columns)")
	Slider( threeAcrossCB[2], aceRowsCB[2], divider1, ca_optionsFrame, 1, 25, 1, "vertical", "Vertical Tiles", 
			"Ignored if 'Horizontal' other than '1'. The number of tiles to descend down the screen before a new column will begin.")
	Slider( threeAcrossCB[3], aceRowsCB[2], divider1, ca_optionsFrame, -10, 10, 1, "indentation", "Indentation", 
			"Each subsequent row (for a horizonta build) will be offset left or right by this amount. Works also for vertical builds."..
			ca_colour_dodgerBlue.."(Use 'minus' for shift left/up)")

	local divider2 = Divider( -4, 17, -24, anchor1, ca_optionsFrame, "Cooldown Options")

	Slider( threeAcrossCB[1], aceRowsCB[1], divider2, ca_optionsFrame, 0, 60, 0.5, "cooldownCountdown", "Remaining Countdown", 
			"Remaining seconds of any queue or mini-icon cooldown to countdown numerically.\n"..ca_colour_dodgerBlue..
			"(A zero means to show no numeric countdown. 'Sweeping Second Hand' will always appear)")
	CheckBox( threeAcrossCB[2], aceRowsCB[1], divider2, ca_optionsFrame, "showCooldowns", "Show Cool Aid",
			"Uncheck this to NEVER SHOW your Cool Aid tiles. '/ca hide' & '/ca show' in chat will also toggle this")
	local anchor2 = CheckBox( threeAcrossCB[1], aceRowsCB[2], divider2, ca_optionsFrame, "showOutsideCombat", "Show Outside Combat",
			"You do not have to be (1) in combat, (2) aggroed, or (3) in a PvE instance for any of your selected options to be shown\n"..
			ca_colour_dodgerBlue.."(Note the 'Show Cool Aid' option. That one is the 'master switch')")
	CheckBox( threeAcrossCB[2], aceRowsCB[2], divider2, ca_optionsFrame, "showWhenCoolingDown", "Show When Cooling Down",
			"This option controls what you will see when a tile is cooling down. The default (checked) is to always see the "..
			"tile (subject to any other options). If you UNCHECK this option then you will NOT see a tile when it is on cooldown, "..
			"save for any specified 'remaining cooldown' countdown. Thus the ability will suddenly 'flash' onto the screen when "..
			"it becomes available.\n"..
			ca_colour_dodgerBlue.."(Note the 'Show Cool Aid' option. That one is the 'master switch')")

	local divider3 = Divider( -4, 17, -24, anchor2, ca_optionsFrame, "Miscellany")

	Slider( threeAcrossCB[1], aceRowsCB[1], divider3, ca_optionsFrame, 0.00, 0.6, 0.01, "updateFrequency",
			"Update Frequency", "How often Cool Aid should check cooldowns. Increase this value to specify a longer pause between "..
			"refreshes. If you are desperate this might reduce cpu usage slightly.\n"..ca_colour_dodgerBlue.."(Push the slider all "..
			"the way to the left to have Cool Aid determine the shortest possible refresh rate)")
	CheckBox( threeAcrossCB[2], aceRowsCB[1], divider3, ca_optionsFrame, "positionLocked", "Locked",
			"If locked you cannot reposition the tiles.\n"..ca_colour_dodgerBlue.."(When unlocked, position the mouse near the "..
			"centre of the first icon. When you receive a special chat message simply hold the left mouse down and drag across the "..
			"screen)")

	ca_optionsFrame:SetScript('OnHide', function(self)
		CoolAid:RepositionFrames()
	end)

	ca_optionsFrame.okay		= function( frame) OkayAllData() end
	ca_optionsFrame.cancel		= function( frame) CancelAllData() end
	ca_optionsFrame.default		= function( frame) DefaultAllData() end

	SetAsideAllData()
	InterfaceOptions_AddCategory(ca_optionsFrame)
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::       COOLDOWNS       :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local function CreateCooldownsButton( name, index, factor)

	local button = CreateFrame("Button","CoolAidButton_"..name..index, ca_cooldownsFrame,"UIPanelButtonTemplate")
	button:SetFrameStrata("BACKGROUND")

--	button:SetSize( 39.25, 39.25)
	button:SetSize( caRound(39.25*7/factor,2), caRound(39.25*7/factor,2))

	button.spellTexture = button:CreateTexture(nil, "OVERLAY")
	button.spellTexture:SetAllPoints(button)
	button.spellID = 0
	button.overlay = CreateFrame("Frame", "CoolAidButton_"..name..index, button, "ActionBarButtonSpellActivationAlert")
	button.overlay:SetParent( button)
	button.overlay:ClearAllPoints()

--	button.overlay:SetSize( 58, 58)
	button.overlay:SetSize( caRound(58*7/factor,2), caRound(58*7/factor,2))

--	button.overlay:SetPoint("TOPLEFT", button, "TOPLEFT", -9.38, 9.38)
	if name == "sSB" then
		button.overlay:SetPoint("TOPLEFT", button, "TOPLEFT", caRound(-9.38*7/factor,2), caRound(9.38*7/factor,2))
	else
		button.overlay:SetPoint("TOPLEFT", button, "TOPLEFT", -9.75, 9.75)
	end

	button:SetScript("OnLeave", function(self)
		ResetCursor()
		GameTooltip:Hide()
	end)

	button:Hide()
	return button
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

local function ProcessButton( button)

-- cdSpellbook is a subset of ca_spellbook. Always refer to cdSpellbook
-- when updating cooldowns, update the DB and let the displayed cdCooldowns be taken care of elsewhere
-- if zeroing an index then hide the overlay beforehand. A non-zero index will receive an overlay elsewhere

	if button == "s1" then
		if selected_spellbook == 0 then					-- Shuffle Up
			cdSCooldowns[selected_sCooldown].overlay:Hide()
			table.insert(CoolAidDB[ca_currentSpec].showCDs_1,selected_sCooldown-1,CoolAidDB[ca_currentSpec].showCDs_1[selected_sCooldown])
			table.remove(CoolAidDB[ca_currentSpec].showCDs_1,selected_sCooldown+1)
			selected_sCooldown = selected_sCooldown-1
			cdSCooldowns[selected_sCooldown].overlay:Show()
		else
			if selected_sCooldown == 0 then				-- Insert Start
				table.insert(CoolAidDB[ca_currentSpec].showCDs_1,1,cdSpellbook[selected_spellbook].spellID)
				cdSpellbook[selected_spellbook].overlay:Hide()
				selected_spellbook = 0
				selected_sCooldown = 1
			else							-- Insert Before
				table.insert(CoolAidDB[ca_currentSpec].showCDs_1,selected_sCooldown,cdSpellbook[selected_spellbook].spellID)
				cdSpellbook[selected_spellbook].overlay:Hide()
				selected_spellbook = 0
			end
		end
	elseif button == "s2" then
		if selected_spellbook == 0 then					-- Shuffle Down
			cdSCooldowns[selected_sCooldown].overlay:Hide()
			table.insert(CoolAidDB[ca_currentSpec].showCDs_1,selected_sCooldown,CoolAidDB[ca_currentSpec].showCDs_1[selected_sCooldown+1])
			table.remove(CoolAidDB[ca_currentSpec].showCDs_1,selected_sCooldown+2)
			selected_sCooldown = selected_sCooldown+1
			cdSCooldowns[selected_sCooldown].overlay:Show()
		else
			if selected_sCooldown == 0 then				-- Insert End
				table.insert(CoolAidDB[ca_currentSpec].showCDs_1,cdSpellbook[selected_spellbook].spellID)
				cdSpellbook[selected_spellbook].overlay:Hide()
				selected_spellbook = 0
				selected_sCooldown = #CoolAidDB[ca_currentSpec].showCDs_1
			else							-- Insert After
				table.insert(CoolAidDB[ca_currentSpec].showCDs_1,selected_sCooldown+1,cdSpellbook[selected_spellbook].spellID)
				cdSpellbook[selected_spellbook].overlay:Hide()
				cdSCooldowns[selected_sCooldown].overlay:Hide()
				selected_spellbook = 0
				selected_sCooldown = selected_sCooldown+1
				cdSCooldowns[selected_sCooldown].overlay:Show()
			end
		end
	elseif button == "s3" then						-- Delete
		table.remove(CoolAidDB[ca_currentSpec].showCDs_1,selected_sCooldown)
		cdSCooldowns[selected_sCooldown].overlay:Hide()
		selected_sCooldown = 0
	elseif button == "s4" then						-- Clear
		if selected_sCooldown ~= 0 then
			cdSCooldowns[selected_sCooldown].overlay:Hide()
			selected_sCooldown = 0
		end
		if selected_spellbook ~= 0 then
			cdSpellbook[selected_spellbook].overlay:Hide()
			selected_spellbook = 0
		end
	end

	ShowCooldowns()
	ShowSpellbook()
	AdjustButtons()
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

local function CoolAidCooldowns()

	ca_cooldownsFrame = CreateFrame( "Frame", "caCooldowns", ca_Interface)
	ca_cooldownsFrame.name = "Cool Aid Cooldowns"
	ca_cooldownsFrame.parent = ca_Interface.name

	local title = ca_cooldownsFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormalLarge")
	title:SetPoint('TOPLEFT',16,-16)
	title:SetText("Cool Aid - Cooldowns")
	title:SetTextColor( NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)

	local divider1 = Divider( 0, interfaceWidth/2 + 22, -15, title, ca_cooldownsFrame, "Shown Cooldowns", interfaceWidth/2 - 5)

	for i=1,numOfSCDs do
		cdSCooldowns[i] = CreateCooldownsButton("sCD",i,7)
		if i == 1 then
			cdSCooldowns[i]:SetPoint( "TOPLEFT", divider1, "BOTTOMLEFT", 0, -5)
		elseif math.floor((i-1)/7) == (i-1)/7 then
			cdSCooldowns[i]:SetPoint( "TOPLEFT", cdSCooldowns[i-7], "BOTTOMLEFT", 0, -2)
		else
			cdSCooldowns[i]:SetPoint( "LEFT", cdSCooldowns[i-1], "RIGHT", 2, 0)
		end
	end

	cd_sButton1 = Button( -2, -44.25, cdSCooldowns[(math.ceil(numOfSCDs/7)*7-6)], ca_cooldownsFrame, "Button s1", "s1")
	cd_sButton1:Hide()
	cd_sButton1:SetScript("OnClick", function ()
		ProcessButton( "s1")
	end)
	cd_sButton2 = Button( 96, 0, cd_sButton1, ca_cooldownsFrame, "Button s2", "s2")
	cd_sButton2:Hide()
	cd_sButton2:SetScript("OnClick", function ()
		ProcessButton( "s2")
	end)
	cd_sButton3 = Button( 0, -23, cd_sButton1, ca_cooldownsFrame, "Button s3", "s3")
	cd_sButton3:Hide()
	cd_sButton3:SetScript("OnClick", function ()
		ProcessButton( "s3")
	end)
	cd_sButton4 = Button( 0, -23, cd_sButton2, ca_cooldownsFrame, "Button s4", "s4")
	cd_sButton4:Hide()
	cd_sButton4:SetScript("OnClick", function ()
		ProcessButton( "s4")
	end)

	-- -- -- -- -- -- -- -- -- --

	local ca_itemMenu = CreateFrame( "Button", "caItemMenu", ca_cooldownsFrame, "UIDropDownMenuTemplate")
	caItemMenu:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 285, -18)
	caItemMenu:Show()

	cdBags = { ca_StrSpellbook, ca_StrEquipment, ca_StrBuffs, ca_StrDebuffs, ca_SpellID, ca_ItemID}
	selected_Source = 1

	local function OnClick(self)
		local newSource = self:GetID()
		if selected_Source ~= newSource then
			UIDropDownMenu_SetSelectedID(ca_itemMenu, newSource)
			selected_Source = newSource
			selected_spellbook = 0
			ShowSpellbook()
		end
	end

	local function initialize(self, level)
		local info = UIDropDownMenu_CreateInfo()
		for i,v in ipairs(cdBags) do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = V
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end
	end
 
	UIDropDownMenu_Initialize(ca_itemMenu, initialize)
	UIDropDownMenu_SetWidth(ca_itemMenu, 190);
	UIDropDownMenu_SetButtonWidth(ca_itemMenu, 100)
	UIDropDownMenu_SetSelectedID(ca_itemMenu, 1)
	UIDropDownMenu_JustifyText(ca_itemMenu, "LEFT")

	caItemMenu:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
		GameTooltip:SetText( "Cooldown Source".."\n\124cFFFFFFFF".."For the 'Spell ID' and 'Item ID' options you will need to enter the ID "..
				"in the edit box to the right.\n\n"..
				"All of your bags may not appear in the menu as CA hasn't yet received the information from the game server. Just "..
				"select the 'Backpack' then try to select the others again.", nil, nil, nil, nil, true)
	end)
	caItemMenu:SetScript("OnLeave", function(self)
		ResetCursor()
		GameTooltip:Hide()
	end)

	-- -- -- -- -- -- -- -- -- --

	local ca_editBox = CreateFrame( "EditBox", "CoolAidEditBox", ca_cooldownsFrame, "InputBoxTemplate")
	ca_editBox:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 525, -22)
	ca_editBox:SetHeight(19)
	ca_editBox:SetWidth(50)
	ca_editBox:SetMaxLetters(6)
	ca_editBox:SetNumeric(true)
	ca_editBox:SetAutoFocus(false)
	ca_editBox:Show()

	ca_editBox:SetScript("OnTextChanged", function(self)
		ca_spellItemID = ca_editBox:GetText()
		ShowSpellbook()
	end)

	-- -- -- -- -- -- -- -- -- --

	local divider2 = Divider( interfaceWidth/2 + 5, 17, -56, title, ca_cooldownsFrame, "Contains:", interfaceWidth/2 - 5)

	local iconsPerRow = 7
	if ca_spellbook then
		if #ca_spellbook > 70 then
			iconsPerRow = ceil(#ca_spellbook/10)
		end
	end

	for i=1,numOfSSpells do
		cdSpellbook[i] = CreateCooldownsButton("sSB",i, iconsPerRow)
		if i == 1 then
			cdSpellbook[i]:SetPoint( "TOPLEFT", divider2, "BOTTOMLEFT", 0, -5)
		elseif floor((i-1)/iconsPerRow) == (i-1)/iconsPerRow then
			cdSpellbook[i]:SetPoint( "TOPLEFT", cdSpellbook[i-iconsPerRow], "BOTTOMLEFT", 0, -2)
		else
			cdSpellbook[i]:SetPoint( "LEFT", cdSpellbook[i-1], "RIGHT", 2, 0)
		end
	end

	ShowSpellbook()
	ShowCooldowns()
	SetAsideAllData()

	ca_cooldownsFrame.okay		= function( frame) OkayAllData() end
	ca_cooldownsFrame.cancel	= function( frame) CancelAllData() end
	ca_cooldownsFrame.default	= function( frame) DefaultAllData() end

	InterfaceOptions_AddCategory(ca_cooldownsFrame)
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::     COOL AID HELP     :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local function CoolAidHelp()

	ca_helpFrame = CreateFrame( "Frame", "caHelp", ca_Interface)
	ca_helpFrame.name = "Help"
	ca_helpFrame.parent = ca_Interface.name

	local title = ca_helpFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormalLarge")
	title:SetPoint('TOPLEFT',16,-16)
	title:SetText("Cool Aid - Help")
	title:SetTextColor( NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)

	local divider1 = Divider( 0, 17, -15, title, ca_helpFrame, "Welcome to Cool Aid")

	local para1 = ca_helpFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	para1:SetTextColor( 1,1,1)
	para1:SetPoint("TOPLEFT", divider1, "BOTTOMLEFT", 0, -10)
	para1:SetWordWrap( true)
	para1:SetJustifyH("LEFT")
	para1:SetJustifyV("TOP")
	para1:SetSize( interfaceWidth, 170)
	para1:SetText( "Cool Aid allows you to select abilities and items and to display these in a moveable and resizable group.\n\n"..
			"It is intended that these abilities and items represent your 'Cool Downs'. To this end a numeric countdown "..
			"of the remaining time until next use is overlayed on the ability/item icon, together with the familiar 'sweeping second "..
			"hand' animation.\n\n"..
			"Check the Options panel to see what customisations are available. Then go to the Cooldowns panel. On the right side of "..
			"panel is a menu of 'sources' for your cooldowns such as your bags, gear, spells and buffs. Experiment. It is very "..
			"intuitive.\n\n"..
			"A limited number of RECHARGE abilities are specially supported. The recharge timer is treated like a cooldown "..
			"timer. See the download website for a list.")

	local divider2 = Divider( 0, 17, -15, para1, ca_helpFrame, "Moving the Tiles")

	local para2 = ca_helpFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	para2:SetTextColor( 1,1,1)
	para2:SetPoint("TOPLEFT", divider2, "BOTTOMLEFT", 0, -10)
	para2:SetWordWrap( true)
	para2:SetJustifyH("LEFT")
	para2:SetJustifyV("TOP")
	para2:SetSize( interfaceWidth, 135)
	para2:SetText( "The tiles are click-through with the exception of the very centre of the first tile.\n\n"..
			"This is the 'sweet spot' for moving the set of tiles.\n\n"..
			"Place the mouse in this spot. You will receive an audible 'ring' sound and a message in chat.\n\n"..
			"With the left mouse button held down, drag the icons around the screen. It is that easy!\n\n"..
			"Nothing happening? The 'Locked' option in the Options panel needs to be unchecked :)")

	local divider4 = Divider( 0, 17, -475, title, ca_helpFrame, "Author")

	local para4 = ca_helpFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	para4:SetTextColor( 1,1,1)
	para4:SetPoint("TOPLEFT", divider4, "BOTTOMLEFT", 0, -10)
	para4:SetWordWrap( true)
	para4:SetJustifyH("LEFT")
	para4:SetJustifyV("TOP")
	para4:SetSize( interfaceWidth, 48)
	para4:SetText( "Copyright by ".. ca_colour_dodgerBlue.."Chris Birch\124r. All rights reserved. Obtain only via official download sites: "..
			"www.wowinterface.com or www.curse.com. "..ca_colour_dodgerBlue.."Taradorei\124r/"..ca_colour_dodgerBlue..
			"Tarocalypse\124r/"..ca_colour_dodgerBlue.."etc\124r @ "..ca_colour_dodgerBlue.."Frostmourne\124r.\n")

	InterfaceOptions_AddCategory(ca_helpFrame)
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::    TROUBLESHOOTING    :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local function CoolAidTrouble()

	ca_troubleFrame = CreateFrame( "Frame", "caTrouble", ca_Interface)
	ca_troubleFrame.name = "Troubleshooting"
	ca_troubleFrame.parent = ca_Interface.name

	local title = ca_troubleFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormalLarge")
	title:SetPoint('TOPLEFT',16,-16)
	title:SetText("Cool Aid - Troubleshooting")
	title:SetTextColor( NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)

	local divider1 = Divider( 0, 17, -15, title, ca_troubleFrame, "Smoke & Mirrors")

	local para1 = ca_troubleFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	para1:SetTextColor( 1,1,1)
	para1:SetPoint("TOPLEFT", divider1, "BOTTOMLEFT", 0, -10)
	para1:SetWordWrap( true)
	para1:SetJustifyH("LEFT")
	para1:SetJustifyV("TOP")
	para1:SetSize( interfaceWidth, 230)
	para1:SetText( "Various abilities evolve as a player levels. Spells can also be altered by Glyphs and Talents. An ability "..
			"can also evolve whilst in combat.\n\n"..
			"Careful. More than one version of a spell might exist. Sometimes the name changes. Sometimes a new icon is provided "..
			"and sometimes a new internal Spell ID is allocated.\n\n"..
			"Blizzard do not have a single way to handle ability changes. This is why Cool Aid provides a 'Spell ID' feature. "..
			"The Wowhead website is an excellent source of spell ID information.\n\n"..
			"Additionally, you might also try a related BUFF (or even Debuff!). Dark Soul is an example here.\n\n"..
			"Careful also with enabled spells such as Presence of Mind as the CD is 'undefined' until the player actually uses "..
			"up the stored spell.\n\n"..
			"This explains why an ability from your Spellbook is not having its cooldown shown by Cool Aid!")

	local divider2 = Divider( 0, 17, -15, para1, ca_troubleFrame, "Troubleshooting Miscellany")

	local para2 = ca_troubleFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	para2:SetTextColor( 1,1,1)
	para2:SetPoint("TOPLEFT", divider2, "BOTTOMLEFT", 0, -10)
	para2:SetWordWrap( true)
	para2:SetJustifyH("LEFT")
	para2:SetJustifyV("TOP")
	para2:SetSize( interfaceWidth, 230)
	para2:SetText( "* Cool Aid's countdown is more fully featured than Blizzard's. To disable theirs, go to 'Game Menu' -> "..
			"'Interface' -> 'ActionBars'. Uncheck 'Show Numbers for Countdowns'. To disable Cool Aid's, move the Options panel 'Remaining "..
			"Cooldown' slider all the way to the left.\n\n"..
			"* All the bags not showing? Click the menu again (the server needs more time to respond).\n\n"..
			"* Tiles not showing? Ensure BOTH 'show' options are selected. Try temporarily resizing to '100'.\n\n"..
			"* Buff cooldown doesn't match the top right of the screen? Correct! Cool Aid displays the COOLDOWN to the next USE, "..
			"rather than the remaining time to buff expiry.\n\n"..
			"* Memory use creeping up? Blizzard throttles garbage collection. It's all good. Manually '/ca gar' to collect "..
			"garbage yourself if you wish to monitor this.\n\n"..
			"* You can enter ANY spell or item ID. May cause a game error message!") 

	InterfaceOptions_AddCategory(ca_troubleFrame)
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::    ABOUT COOL AID     :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local function CoolAidAbout()

	ca_aboutFrame = CreateFrame( "Frame", "caAbout", ca_Interface)
	ca_aboutFrame.name = "About"
	ca_aboutFrame.parent = ca_Interface.name

	local title = ca_aboutFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormalLarge")
	title:SetPoint('TOPLEFT',16,-16)
	title:SetText("Cool Aid - About")
	title:SetTextColor( NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)

	local divider1 = Divider( 0, 17, -15, title, ca_aboutFrame, "A Meeting of Two Old Friends")

	local para1 = ca_aboutFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	para1:SetTextColor( 1,1,1)
	para1:SetPoint("TOPLEFT", divider1, "BOTTOMLEFT", 0, -10)
	para1:SetWordWrap( true)
	para1:SetJustifyH("CENTER")
	para1:SetJustifyV("TOP")
	para1:SetSize( interfaceWidth, 440)
	para1:SetText( 'The Pandaren Monk sat next to the disheveled, exhausted Orc and enquired "Tell me of your travels".\n\n'..
			'The battle-scarred Orc, with forearms resting on his knees, looked wearily forward and sighed.\n'..
			'"I\'ve walked the desert of Tanaris in search of the magicial Noggenfogger elixir."\n'..
			'"I\'ve trecked to the Tempest Keep in farthermost Outlands\n'..
			'to obtain a mythical can of Whoop-Ass."\n'..
			'"And I\'ve explored the highest reaches of Storm Peaks for the magnificent Vrykul Drinking Horn."\n'..
			'"But nothing, nothing prepared me for..."\n\n'..
			ca_colour_dodgerBlue..'--<(o):|:(o)>--\124r\n'..
			'COOL AID\n'..
			ca_colour_dodgerBlue..'--<(o):|:(o)>--\124r\n\n'..
			'Tarocalypse smiled wisely at the Orc.\n'..
			'"It was foretold in the winds of Kun-Lai Summit my dear friend."\n'..
			'"And before that in the depths of the Molten Core where", he paused to reflect,\n'..
			'"you should never be \'too soon\'."\n'..
			'"And alas the many brethren we lost in Karazhan,\n'..
			'they were just not prepared when the curtain went up."\n\n'..
			'"Bah, all they blew was hot air!" Grumbled Taraezor.\n\n'..
			'They both looked sideways and exchanged smiles,\n'..
			'silently recalling battles they had fought long ago.\n\n'..
			'Taraezor was the first to speak.\n'..
			'"Tell me my good friend. It is clear that when I need help with cooling down,\n'..
			'I surely need Cool Aid."\n'..
			'"But I need to know this..."\n'..
			'He leant closer to the wise Pandaren and grinned.\n\n'..
			'"Are you drinking the Cool Aid too?"\n')

	InterfaceOptions_AddCategory(ca_aboutFrame)
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::       FUN STUFF       :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

ca_salutation = { ["BloodElf"] = "Bal'a dash, malanore ", ["Draenei"] = "Chronakai kristor ", ["Dwarf"] = "Ya got my attention ",
		["Gnome"] = "Pleased to meet you ", ["Goblin"] = "Catch ya on the flip side ", ["Human"] = "Light be with you ",
		["NightElf"] = "Elune light your path ", ["Orc"] = "Lok'tar! ", ["Pandaren"] = "Tell me of your travels ",
		["Tauren"] = "Ah, I've been expecting you ", ["Troll"] = "You come get da Voodoo ", ["Scourge"] = "Our time will come ",
		["Worgen"] = "Any friend of Greymane is a friend of mine ", }

ca_salutation_Sound = {
		["BloodElf"] = "Sound/Creature/Npcbloodelffemalenoble/Npcbloodelffemalenoblegreeting08.Ogg", -- Female
		["Draenei"] = "Sound/Creature/Npcdraeneifemalemilitary/Npcdraeneifemalemilitarygreeting07.Ogg", -- Female
		["Dwarf"] = "Sound/Creature/Dwarfmalegrimnpc/Dwarfmalegrimnpcgreeting03.Ogg", -- Male
		["Gnome"] = "Sound/Creature/Gnomefemalenerdynpc/Gnomefemalenerdynpcgreeting03.Ogg", -- Female
		["Goblin"] = "Sound/Creature/Goblincivf/Vo_Goblincivf_Farewell03.Ogg", -- Female
		["Human"] = "Sound/Creature/Humanfemaleofficialnpc/Humanfemaleofficialnpcgreeting04.Ogg", -- Female
		["NightElf"] = "Sound/Creature/Nightelfmalestandardnpc/Nightelfmalestandardnpcfarewell02.Ogg", -- Male
		["Orc"] = "Sound/Creature/Orcmalestandardnpc/Orcmalestandardnpcgreeting05.Ogg", -- Male
		["Pandaren"] = "Sound/Creature/Pandarencivf/Vo_Pandaren_Female_Standard_Greeting_02.Ogg", -- Male
		["Tauren"] = "Sound/Creature/Taurenmaleeldernpc/Taurenmaleeldernpcgreeting05.Ogg", -- Male
		["Troll"] = "Sound/Creature/Trollfemalelaidbacknpc/Trollfemalelaidbacknpcgreeting04.Ogg", -- Female
		["Scourge"] = "Sound/Creature/Undeadfemalemagicnpc/Undeadfemalemagicnpcfarewell07.Ogg", -- Female
		["Worgen"] = "Sound/Creature/Worgencivm/Vo_Worgencivm_Greeting06.Ogg", } -- Male

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::    INITIALISATION     :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

function CoolAid:InitialiseInterface()
	
	if ca_Interface == nil then
		ca_Interface = CreateFrame( "Frame", "Cool Aid", UIParent)
		ca_Interface.name = "Cool Aid"
		InterfaceOptions_AddCategory(ca_Interface)
		CoolAidOptions()
		CoolAidCooldowns()
		CoolAidHelp()
		CoolAidTrouble()
		CoolAidAbout()
	else
		ShowCooldowns()
		ShowSpellbook()
		AdjustButtons()
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

function CoolAid:DataDefaultsSetup()

	if not CoolAidDB then CoolAidDB = {} end
	if not CoolAidDB[ca_currentSpec] then
		CoolAidDB[ca_currentSpec] = {}
	end

	CoolAidDB.defaults = {

		cooldownCountdown	= 10,		-- Options Panel
		debug			= 0,		-- via /ca deb {num}
		horizontal		= 5,		-- Options Panel
		indentation		= 0,		-- Options Panel
		positionLocked		= 0,		-- Options Panel
		showCDs_1		= {},		-- Cooldowns Panel
		showCooldowns		= 1,		-- Options Panel
		showOutsideCombat	= 0,		-- Options Panel
		showWhenCoolingDown	= 1,		-- Options Panel
		tilePosX		= 0,
		tilePosY		= 0,
		tileRelP		= "CENTER",
		tileSize		= 74,		-- Options Panel
		updateFrequency		= 0.09,		-- Options Panel
		version			= 1,
		vertical		= 5,		-- Options Panel
	}

	for k,v in pairs(CoolAidDB.defaults) do
		if not CoolAidDB[ca_currentSpec][k] then
			CoolAidDB[ca_currentSpec][k] = v
			caDebug("DDS: Set DB "..k.."="..tostring(v).." (new)","New DB")
		end
	end
end
